#Script to Output Annual Probability of Deforestation Map

# clear workspace
rm(list=ls())

#Load packages
library(maptools)

#set working directory
setwd("~/Filzbach Examples/workspace")

#Get the coordinates of each pixel (Spatial Points):
print("Reading data in...")
data<-readAsciiGrid("predfor_i0_0yr.asc")
print("Calculating spatial points...")
spatial.points<-as.data.frame(SpatialPoints(data))
data.mat<-as.matrix(data)

#Impo rt data to run code
iterations<-100
years<-3

for(i in 0:years){
	print(paste("Starting year ",i,sep=""))
	alldef<-ifelse(is.na(data.mat),0,0)
	for(j in 1:iterations){
		print(paste("Iteration ",j,sep=""))
		defor<-as.matrix(readAsciiGrid(paste("preddef_i",j-1,"_",i,"yr.asc",sep="")))

		newdef<-ifelse(is.na(defor),0,defor)

		alldef<-alldef+newdef
	}
	
	#Add NoData values
	prob.year<-ifelse(is.na(data.mat),-9999,alldef)

	#Get vector
	prob.vec<-c(prob.year)

	#Export ascii map
	print("Exporting final map in .ASC")
	out<-data.frame(prob.vec,spatial.points)
	coordinates(out)=~s1+s2
	gridded(out)=TRUE
	out.grid<-as(out,"SpatialGridDataFrame")
	writeAsciiGrid(out.grid,paste("probdefyear",i,".asc",sep=""),attr=1,na.value=-9999)
	
}



