# -*- coding: utf-8 -*-
"""
Created on Thu Nov 01 17:24:17 2018

@author: mv39zilo
"""

import numpy as np
import os
from osgeo import ogr
import shutil
from glob import glob

import MacPyver as mp

out_path = r"~\Filzbach Examples\workspace"

forest_path = out_path + "\\forest_repro_res.tif"

forest = mp.raster.tiff.read_tif(forest_path, 1)

inpath =  out_path

# predictor layers
# landuse
lu_path = inpath + "\LU_PA_repro_res.tif"

# provinces (not modeled)
province_path = inpath + "\\province_repro_res.tif"


lu = mp.raster.tiff.read_tif(lu_path, 1)
np.unique(lu)
lu_types = range(1,8)

province_layer = mp.raster.tiff.read_tif(province_path, 1)
np.unique(province_layer)
provinces = range(1,8)


# starting forest

forest_0 = forest
forest_0 = np.where((forest_0 >= 1) & (forest_0 <= 17), 1,0)



"""mp.raster.tiff.write_tif(forest_path,
out_path + '/forest_2000.tif', forest_0,  option='compress=deflate')
"""

# make deforestation for 3 time periods

# period 1 (2001-2011)
forest_1 = forest
deforest_1 = np.where((forest_1 >= 1) & (forest_1 < 12), 1,0)

# period 2 (2012-2016)
forest_2 = forest
deforest_2 = np.where((forest_2 >= 12) & (forest_2 < 17), 1, 0)


# forest in end (2017)

forest_3 = forest
forest_3 = np.where((forest_3 == 17), 1, 0)
np.unique(forest_3)
"""
mp.raster.tiff.write_tif(forest_path,
out_path + '/forest_2017.tif', forest_3,  option='compress=deflate')
"""


# prepare table
deforestation_data = open(out_path  + "\deforestation_data_11y_5y.csv",'w')
# write header
deforestation_data.write("type,lu,province,year,nr_pixel \n")

# starting period
year = "2000"
forest_total = np.sum(forest_0)
deforestation_data.write("forest,none,Borneo,"+ str(year) + ", " + str(forest_total) + " \n")
for lu_type in lu_types:
    print(lu_type)
    forest_total_lu = np.sum(np.where((forest_0 == 1) & (lu == lu_type), 1, 0))
    deforestation_data.write("forest,"+ str(lu_type) +",Borneo,"+ str(year) + ", " + str(forest_total_lu) + " \n")
for province in provinces: 
    print(province)
    forest_total_prov = np.sum(np.where((forest_0 == 1) & (province_layer == province), 1, 0))
    deforestation_data.write("forest,none,"+ str(province)+ "," +str(year) + ", " + str(forest_total_prov) + " \n")
    for lu_type in lu_types:
        forest_total_lu_prov = np.sum(np.where((forest_0 == 1) & (lu == lu_type) & (province_layer == province), 1, 0))
        deforestation_data.write("forest,"+ str(lu_type) +","+ str(province)+ "," + str(year) + ", " + str(forest_total_lu_prov) + " \n")  

# period 1
year = "2001-2011"
forest_loss_1 = np.sum(deforest_1)
deforestation_data.write("loss,none,Borneo,"+ str(year) + ", " + str(forest_loss_1) + " \n")
for lu_type in lu_types:
    print(lu_type)
    forest_loss_1_lu = np.sum(np.where((deforest_1 == 1) & (lu == lu_type), 1, 0))
    deforestation_data.write("loss,"+ str(lu_type) +",Borneo,"+ str(year) + ", " + str(forest_loss_1_lu) + " \n")
for province in provinces: 
    print(province)
    forest_loss_1_prov = np.sum(np.where((deforest_1 == 1) & (province_layer == province), 1, 0))
    deforestation_data.write("loss,none,"+ str(province)+ "," +str(year) + ", " + str(forest_loss_1_prov) + " \n")
    for lu_type in lu_types:
        forest_loss_1_lu_prov = np.sum(np.where((deforest_1 == 1) & (lu == lu_type) & (province_layer == province), 1, 0))
        deforestation_data.write("loss,"+ str(lu_type) +","+ str(province)+ "," + str(year) + ", " + str(forest_loss_1_lu_prov) + " \n")  
        
        
year = "2012-2016"
forest_loss_2 = np.sum(deforest_2)
deforestation_data.write("loss,none,Borneo,"+ str(year) + ", " + str(forest_loss_2) + " \n")
 #   deforestation_data.write("forest,none,Borneo,1000,"+ str(year) + ", " + str(forest_1000_year) + " \n")  
for lu_type in lu_types:
    forest_loss_2_lu = np.sum(np.where((deforest_2 == 1) & (lu == lu_type), 1, 0))
    deforestation_data.write("loss,"+ str(lu_type) +",Borneo,"+ str(year) + ", " + str(forest_loss_2_lu) + " \n")
for province in provinces: 
    forest_loss_2_prov = np.sum(np.where((deforest_2 == 1) & (province_layer == province), 1, 0))
    deforestation_data.write("loss,none,"+ str(province)+"," + str(year) + ", " + str(forest_loss_2_prov) + " \n")
    for lu_type in lu_types:
        forest_loss_2_lu_prov = np.sum(np.where((deforest_2 == 1) & (lu == lu_type) & (province_layer == province), 1, 0))
        deforestation_data.write("loss,"+ str(lu_type) +","+ str(province)+"," + str(year) + ", " + str(forest_loss_2_lu_prov) + " \n")         
        
year = "2017"
forest_total = np.sum(forest_3)
deforestation_data.write("forest,none,Borneo,"+ str(year) + ", " + str(forest_total) + " \n")
for lu_type in lu_types:
    print(lu_type)
    forest_total_lu = np.sum(np.where((forest_3 == 1) & (lu == lu_type), 1, 0))
    deforestation_data.write("forest,"+ str(lu_type) +",Borneo,"+ str(year) + ", " + str(forest_total_lu) + " \n")
for province in provinces: 
    print(province)
    forest_total_prov = np.sum(np.where((forest_3 == 1) & (province_layer == province), 1, 0))
    deforestation_data.write("forest,none,"+ str(province)+ "," +str(year) + ", " + str(forest_total_prov) + " \n")
    for lu_type in lu_types:
        forest_total_lu_prov = np.sum(np.where((forest_3 == 1) & (lu == lu_type) & (province_layer == province), 1, 0))
        deforestation_data.write("forest,"+ str(lu_type) +","+ str(province)+ "," + str(year) + ", " + str(forest_total_lu_prov) + " \n")  
        
print("finished")



deforestation_data.close()  
    


