# -*- coding: utf-8 -*-
"""
Created on Tue Nov 06 18:45:54 2018

@author: mv39zilo
"""

import numpy as np
import os
from osgeo import ogr
import shutil
from glob import glob
import datetime


import MacPyver as mp

# for each prediction (1:100), get the forest loss per province and the loss rate
# fix this
in_path = r"~\Filzbach Examples\workspace"

out_path = in_path

province_path =  r"~\Filzbach Examples\workspace\repro_res\province_repro_res.tif"
province = mp.raster.tiff.read_tif(province_path, 1)
np.unique(province)
provinces = range(1,8)

# predictor layers
# landuse
lu_path = r"~\Filzbach Examples\workspace\repro_res\LU_PA_repro_res.tif"

lu = mp.raster.tiff.read_tif(lu_path, 1)
np.unique(lu)
lu_types = range(1,8)

# forest and we use 2011, because then the deforestation from 2012-2016 is calculated from here
forest_path = r"~\Filzbach Examples\workspace\repro_res\forest_2012_repro_res.tif"
forest = mp.raster.tiff.read_tif(forest_path, 1)
np.unique(forest)
forest = np.where(forest == 1, 1, 0)



# import OU distribution 
ou_2015_path = ou_path + "\prediction_map_2015_2017-03-01_repro_res.tif"
ou_2015 = mp.raster.tiff.read_tif(ou_2015_path, 1)
np.max(ou_2015)

pop_path = ou_path + "\meta_kalsarsab_20002015_diss_no_reintro_repro_res.tif"
pop = mp.raster.tiff.read_tif(pop_path, 1)
np.unique(pop)

# clip with meta-pops
ou_2015 = np.where(pop != 0, ou_2015, 0)

ou_truly_path = ou_path + "\OUPrediction_join_repro_res.tif" # this is the last time slice
ou_truly = mp.raster.tiff.read_tif(ou_truly_path, 1)
np.unique(ou_truly)


years = range(0, 4)

start = datetime.datetime.now()
table = open(out_path  + "\\future_deforestation_ou_5y_prov_lu_I_roads.csv",'w')
# write header
table.write("i, category,class,province,type,year,nr_iteration,nr_pixel, nr_ou, nr_ou_truly \n")

# whole of Borneo
# start with a forest area and then I deduce this area 

# start with the iteration, go through each year and deduce it from forest

for i in range(0,100):
#for i in range(0,2):
    print("i"+str(i))
    forest_left_1 = forest
    forest_left_2 = forest
    for year in years:      
        print("year" + str(year))
        preddef = np.loadtxt(in_path + "\preddef_i"+ str(i)+ "_" + str(year) + "yr.asc", skiprows=6)
        for province_i in provinces:
        #    print("province" + str(province_i))
            # the NA values are also zero!
            forest_loss = np.sum(np.where((preddef == 1) & (province == province_i), 1, 0 ))
            ou_loss = np.sum(np.where((preddef == 1) & (province == province_i), ou_2015, 0 ))
            ou_loss_truly = np.sum(np.where((preddef == 1) & (province == province_i), ou_truly, 0 ))
            table.write(str(i) + ",NA,NA," + str(province_i) + ",forest_loss,"+ str(year)+ "," + str(i) + "," + str(forest_loss) + "," + str(ou_loss)+ ","+ str(ou_loss_truly)+"\n")
            # deduce the areas with one from the forest area
            forest_left_1 = forest_left_1 - preddef
            forest_area = np.sum(np.where((forest_left_1 == 1) & (province == province_i), 1, 0 ))
            ou_left = np.sum(np.where((forest_left_1 == 1) & (province == province_i), ou_2015, 0 ))
            ou_left_truly = np.sum(np.where((forest_left_1 == 1) & (province == province_i), ou_truly, 0 ))
            table.write(str(i) + ",NA,NA," + str(province_i) + ",forest,"+ str(year)+ "," + str(i) + "," + str(forest_area) + "," + str(ou_left)+ ","+ str(ou_left_truly)+"\n")
            for lu_type in lu_types:
                forest_loss = np.sum(np.where((preddef == 1) & (province == province_i) & (lu == lu_type), 1, 0 ))
                ou_loss = np.sum(np.where((preddef == 1) & (province == province_i) & (lu == lu_type), ou_2015, 0 ))
                ou_loss_truly = np.sum(np.where((preddef == 1) & (province == province_i) & (lu == lu_type), ou_truly, 0 ))
                table.write(str(i) + ",lu,"+ str(lu_type)+","  + str(province_i) + ",forest_loss,"+ str(year)+ "," + str(i) + "," + str(forest_loss)+ "," + str(ou_loss)+ ","+ str(ou_loss_truly)+"\n")
                # deduce the areas with one from the forest area
                forest_area = np.sum(np.where((forest_left_1 == 1) &  (province == province_i) & (lu == lu_type), 1, 0 ))
                ou_left = np.sum(np.where((forest_left_1 == 1) & (province == province_i)& (lu == lu_type), ou_2015, 0 ))
                ou_left_truly = np.sum(np.where((forest_left_1 == 1) & (province == province_i)& (lu == lu_type), ou_truly, 0 ))
                table.write(str(i) + ",lu,"+ str(lu_type)+","  + str(province_i) + ",forest,"+ str(year)+ "," + str(i) + "," + str(forest_area) + "," + str(ou_left)+ ","+ str(ou_left_truly)+"\n")
        for lu_type in lu_types:
            forest_loss = np.sum(np.where((preddef == 1)  & (lu == lu_type), 1, 0 ))
            ou_loss = np.sum(np.where((preddef == 1) & (lu == lu_type), ou_2015, 0 ))
            ou_loss_truly = np.sum(np.where((preddef == 1) & (lu == lu_type), ou_truly, 0 ))
            table.write(str(i) + ",lu,"+ str(lu_type)+",Borneo,forest_loss,"+ str(year)+ "," + str(i) + "," + str(forest_loss) + "," + str(ou_loss)+ ","+ str(ou_loss_truly)+"\n")
            # deduce the areas with one from the forest area
            forest_left_2 = forest_left_2 - preddef
            forest_area = np.sum(np.where((forest_left_2 == 1) & (lu == lu_type), 1, 0 ))
            ou_left = np.sum(np.where((forest_left_2 == 1) & (lu == lu_type), ou_2015, 0 ))
            ou_left_truly = np.sum(np.where((forest_left_2 == 1) & (lu == lu_type), ou_truly, 0 ))
            table.write(str(i) + ",lu,"+ str(lu_type)+",Borneo,forest,"+ str(year)+ "," + str(i) + "," + str(forest_area)  + "," + str(ou_left)+ ","+ str(ou_left_truly)+"\n")
 
print("finished")
table.close()  
    
end =  datetime.datetime.now()
print end - start 