# -*- coding: utf-8 -*-
"""
Created on Tue Nov 06 18:45:54 2018

@author: mv39zilo
"""

import numpy as np
import os
from osgeo import ogr
import shutil
from glob import glob
import datetime


import MacPyver as mp

# for each prediction (1:100), get the forest loss per province and the loss rate
# fix this
in_path = r"~\Filzbach Examples\workspace\"

out_path = in_path

province_path =  r"~\Filzbach Examples\workspace\repro_res\province_repro_res.tif"
province = mp.raster.tiff.read_tif(province_path, 1)
np.unique(province)
provinces = range(1,8)

# predictor layers
# landuse
lu_path = r"~\Filzbach Examples\workspace\repro_res\LU_PA_repro_res.tif"

lu = mp.raster.tiff.read_tif(lu_path, 1)
np.unique(lu)
lu_types = range(1,8)




# import OU distribution (mine and truly)
ou_2015_path = ou_path + "\prediction_map_2015_2017-03-01_repro_res.tif"
ou_2015 = mp.raster.tiff.read_tif(ou_2015_path, 1)
np.max(ou_2015)
np.unique(ou_2015)
pop_path = ou_path + "\meta_kalsarsab_20002015_diss_no_reintro_repro_res.tif"
pop = mp.raster.tiff.read_tif(pop_path, 1)
np.unique(pop)

# clip with meta-pops
ou_2015 = np.where((pop != 0) & (ou_2015>0.01), ou_2015, 0)


# we use forests from 2016 and then look into each lu class


# forest and we use 2011, because then the deforestation from 2012-2016 is calculated from here
forest_path = r"~\Filzbach Examples\workspace\forest_repro_res.tif"

# layer 1 (forest in 2016)

forest_1 = mp.raster.tiff.read_tif(forest_path, 1)
forest_1 = np.where(((forest_1 == 17)), 1, -9999)

mp.raster.tiff.write_tif(forest_path,
out_path + '/deforestation_2017_repro_res.tif', forest_1, nodata=-9999, option='compress=deflate', dtype=4)

ou_2017 = np.where(forest_1 == 1, ou_2015, 0)

mp.raster.tiff.write_tif(forest_path,
out_path + '/ou_2017.tif', ou_2017, nodata=0, option='compress=deflate', dtype=4)



year = 3
# here I need the accumulated over time intervals


start = datetime.datetime.now()


table = open(out_path  + "\\ou_baseline.csv",'w')
# write header
table.write("i, category,class,province,type,year, nr_ou "+"\n")   

for i in range(0,100):
#for i in range(0,2):
#    print(i)
    predfor =  np.loadtxt(in_path + "\predfor_i"+ str(i)+ "_" + str(year) + "yr.asc", skiprows=6)
    preddef =  np.loadtxt(in_path + "\preddef_i"+ str(i)+ "_" + str(year) + "yr.asc", skiprows=6)

    for province_i in provinces:
        ou_current = np.sum(np.where(province == province_i, ou_2017, 0))
        table.write(str(i) + ",NA,NA," + str(province_i) + ",ou,"+ "0" + "," + str(ou_current)+"\n")    
        ou_loss = np.sum(np.where((preddef == 1) & (province == province_i), ou_2017, 0 ))
        table.write(str(i) + ",NA,NA," + str(province_i) + ",ou_loss,"+ str(year) + "," + str(ou_loss)+"\n")    
        ou_left = np.sum(np.where((predfor == 1) & (province == province_i), ou_2017, 0 ))
        table.write(str(i) + ",NA,NA," + str(province_i) + ",ou,"+ str(year)+  "," + str(ou_left)+ "\n")
        for lu_type in lu_types:
            ou_current = np.sum(np.where((province == province_i) & (lu == lu_type), ou_2017, 0 ))
            table.write(str(i) + ",lu,"+ str(lu_type)+","  + str(province_i) + ",ou,"+ "0" + "," + str(ou_current)+ "\n")
            ou_loss = np.sum(np.where((preddef == 1) & (province == province_i) & (lu == lu_type), ou_2017, 0 ))
            table.write(str(i) + ",lu,"+ str(lu_type)+","  + str(province_i) + ",ou_loss,"+ str(year)+ "," + str(ou_loss)+"\n")
            ou_left = np.sum(np.where((predfor == 1) & (province == province_i)& (lu == lu_type), ou_2017, 0 ))
            table.write(str(i) + ",lu,"+ str(lu_type)+","  + str(province_i) + ",ou,"+ str(year) + "," + str(ou_left)+ "\n")
    for lu_type in lu_types:
        ou_current = np.sum(np.where((lu == lu_type), ou_2017, 0 ))
        table.write(str(i) + ",lu,"+ str(lu_type)+",Borneo,ou,"+ "0"+ "," + str(ou_current)+ ","+"\n")
        ou_loss = np.sum(np.where((preddef == 1) & (lu == lu_type), ou_2017, 0 ))
        table.write(str(i) + ",lu,"+ str(lu_type)+",Borneo,ou_loss,"+ str(year) + "," + str(ou_loss)+"\n")
        ou_left = np.sum(np.where((predfor == 1) & (lu == lu_type), ou_2017, 0 ))
        table.write(str(i) + ",lu,"+ str(lu_type)+",Borneo,ou,"+ str(year)+ "," + str(ou_left)+ ","+"\n")
 
print("finished")
table.close()  
    
end =  datetime.datetime.now()
print end - start 


# calculating
# percent of the area of non designation
np.sum(np.where((lu == 1) & (ou_2017 > 0.01), 1, 0)) * 100.00 / np.sum(np.where((ou_2017 > 0.01), 1, 0))

# number of ou currently (not in future)
np.sum(np.where((lu == 1), ou_2017, 0)) * 100 / np.sum(ou_2017)